package com.gxwebsoft.apps.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.apps.service.HualalaShopService;
import com.gxwebsoft.apps.entity.HualalaShop;
import com.gxwebsoft.apps.param.HualalaShopParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 哗啦啦门店管理控制器
 *
 * @author 科技小王子
 * @since 2023-01-12 18:24:44
 */
@Api(tags = "哗啦啦门店管理管理")
@RestController
@RequestMapping("/api/apps/hualala-shop")
public class HualalaShopController extends BaseController {
    @Resource
    private HualalaShopService hualalaShopService;

    @PreAuthorize("hasAuthority('apps:hualalaShop:list')")
    @OperationLog
    @ApiOperation("分页查询哗啦啦门店管理")
    @GetMapping("/page")
    public ApiResult<PageResult<HualalaShop>> page(HualalaShopParam param) {
        PageParam<HualalaShop, HualalaShopParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaShopService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(hualalaShopService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaShop:list')")
    @OperationLog
    @ApiOperation("查询全部哗啦啦门店管理")
    @GetMapping()
    public ApiResult<List<HualalaShop>> list(HualalaShopParam param) {
        PageParam<HualalaShop, HualalaShopParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaShopService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(hualalaShopService.listRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaShop:list')")
    @OperationLog
    @ApiOperation("根据id查询哗啦啦门店管理")
    @GetMapping("/{id}")
    public ApiResult<HualalaShop> get(@PathVariable("id") Integer id) {
        return success(hualalaShopService.getById(id));
        // 使用关联查询
        //return success(hualalaShopService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('apps:hualalaShop:save')")
    @OperationLog
    @ApiOperation("添加哗啦啦门店管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody HualalaShop hualalaShop) {
        if (hualalaShopService.save(hualalaShop)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaShop:update')")
    @OperationLog
    @ApiOperation("修改哗啦啦门店管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody HualalaShop hualalaShop) {
        if (hualalaShopService.updateById(hualalaShop)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaShop:remove')")
    @OperationLog
    @ApiOperation("删除哗啦啦门店管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (hualalaShopService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaShop:save')")
    @OperationLog
    @ApiOperation("批量添加哗啦啦门店管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<HualalaShop> list) {
        if (hualalaShopService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaShop:update')")
    @OperationLog
    @ApiOperation("批量修改哗啦啦门店管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<HualalaShop> batchParam) {
        if (batchParam.update(hualalaShopService, "shop_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaShop:remove')")
    @OperationLog
    @ApiOperation("批量删除哗啦啦门店管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (hualalaShopService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
